SystemOrganization addCategory: #OCLoader!

Object subclass: #OCompletionLoader
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OCLoader'!

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 5/28/2009 10:04'!
hasECOB
	| panel |
	panel := Smalltalk at: #OBDefinitionPanel ifAbsent: [^ false].
	panel ifNil: [^false].
	panel methodDict at: #completionController ifAbsent: [^false].
	^ true! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 21:31'!
hasECompletion
	Smalltalk at: #ECController ifAbsent: [^ false].
	^ true! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'djr 1/4/2010 21:48'!
hasNewSqueakEditor
	Smalltalk at: #SmalltalkEditor ifAbsent: [^ false].
	^ true! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 5/28/2009 10:02'!
hasOB
	Smalltalk at: #OBBrowser ifAbsent: [^ false].
	^ true! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 21:31'!
hasShout
	Smalltalk at: #PluggableShoutMorph ifAbsent: [^ false].
	^ true! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 7/28/2009 15:52'!
initialize
	self installShout.
	self onSqueak: [self installEcompletionSqueak].
	self installOCompletion.
	self installOCompletionOB.! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'djr 1/4/2010 21:51'!
installEcompletionSqueak
	self hasECompletion ifFalse: [
		self hasNewSqueakEditor ifTrue: [ 
			Installer squeaksource project: 'eCompletion'; install: 'ECompletion-djr.squeaktrunk.103'
		] ifFalse: [
			Installer squeaksource project: 'eCompletion'; install: 'ECompletion-damiencassou.102.mcz'
		]
	]! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'tfel 5/2/2010 17:19'!
installOCompletion
	self onPharo: [Installer squeaksource project: 'OCompletion'; install: 'Ocompletion'.
					 (Smalltalk classNamed: #ECToolSet) ifNotNil: [:toolSet | toolSet register]].
	self onSqueak: [Installer squeaksource project: 'OCompletion'; install: 'Ocompletion-RomainRobbes.58.mcz'].
	! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'tfel 5/2/2010 17:19'!
installOCompletionOB
	self hasOB ifTrue: [
		self onSqueak: [
			self hasECOB ifFalse: [Installer squeaksource project: 'eCompletion'; install: 'ECompletionOmniBrowser'].
			Installer squeaksource project: 'OCompletion'; install: 'OCForOB-rr.2.mcz'].
		self onPharo: [Installer squeaksource project: 'OCompletion'; install: 'OCForOB']]! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 22:56'!
installShout
	self hasShout ifFalse: [Installer squeaksource project: 'shout'; install: 'Shout.3.15-tween.70.mcz']! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 5/11/2009 23:28'!
isPharo
	^ Smalltalk version beginsWith: 'Pharo'! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 7/28/2009 15:51'!
onPharo: aBlock
	self isPharo ifTrue: [aBlock value]! !

!OCompletionLoader class methodsFor: 'as yet unclassified' stamp: 'rr 7/28/2009 15:51'!
onSqueak: aBlock
	self isPharo ifFalse: [aBlock value]! !
OCompletionLoader initialize!
